Scala Standard Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
    - `scala.collection.parallel.immutable` - Immutable, parallel data-structures such as `ParVector`, `ParRange`, `ParHashMap` or `ParHashSet`
    - `scala.collection.parallel.mutable` - Mutable, parallel data-structures such as `ParArray`, `ParHashMap`, `ParTrieMap` or `ParHashSet`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package util
  Definition Classes
    scala
-  package control
  Definition Classes
    util
-  object Exception

  Classes representing the components of exception handling.

  Classes representing the components of exception handling.

  Each class is independently composable.

  This class differs from scala.util.Try in that it focuses on composing exception handlers rather than composing behavior. All behavior should be composed first and fed to a Catch object using one of the `opt`, `either` or `withTry` methods. Taken together the classes provide a DSL for composing catch and finally behaviors.

  ##### Examples

  Create a `Catch` which handles specified exceptions.

      import scala.util.control.Exception._
      import java.net._

      val s = "http://www.scala-lang.org/"

      // Some(http://www.scala-lang.org/)
      val x1: Option[URL] = catching(classOf[MalformedURLException]) opt new URL(s)

      // Right(http://www.scala-lang.org/)
      val x2: Either[Throwable,URL] =
        catching(classOf[MalformedURLException], classOf[NullPointerException]) either new URL(s)

      // Success(http://www.scala-lang.org/)
      val x3: Try[URL] = catching(classOf[MalformedURLException], classOf[NullPointerException]) withTry new URL(s)

      val defaultUrl = new URL("http://example.com")
      //  URL(http://example.com) because htt/xx throws MalformedURLException
      val x4: URL = failAsValue(classOf[MalformedURLException])(defaultUrl)(new URL("htt/xx"))

  Create a `Catch` which logs exceptions using `handling` and `by`.

      def log(t: Throwable): Unit = t.printStackTrace

      val withThrowableLogging: Catch[Unit] = handling(classOf[MalformedURLException]) by (log)

      def printUrl(url: String) : Unit = {
        val con = new URL(url) openConnection()
        val source = scala.io.Source.fromInputStream(con.getInputStream())
        source.getLines.foreach(println)
      }

      val badUrl = "htt/xx"
      // Prints stacktrace,
      //   java.net.MalformedURLException: no protocol: htt/xx
      //     at java.net.URL.(URL.java:586)
      withThrowableLogging { printUrl(badUrl) }

      val goodUrl = "http://www.scala-lang.org/"
      // Prints page content,
      //   <!DOCTYPE html>
      //   <html>
      withThrowableLogging { printUrl(goodUrl) }

  Use `unwrapping` to create a `Catch` that unwraps exceptions before rethrowing.

      class AppException(cause: Throwable) extends RuntimeException(cause)

      val unwrappingCatch: Catch[Nothing] = unwrapping(classOf[AppException])

      def calcResult: Int = throw new AppException(new NullPointerException)

      // Throws NPE not AppException,
      //   java.lang.NullPointerException
      //     at .calcResult(<console>:17)
      val result = unwrappingCatch(calcResult)

  Use `failAsValue` to provide a default when a specified exception is caught.

      val inputDefaulting: Catch[Int] = failAsValue(classOf[NumberFormatException])(0)
      val candidatePick = "seven" // scala.io.StdIn.readLine()

      // Int = 0
      val pick = inputDefaulting(candidatePick.toInt)

  Compose multiple `Catch`s with `or` to build a `Catch` that provides default values varied by exception.

      val formatDefaulting: Catch[Int] = failAsValue(classOf[NumberFormatException])(0)
      val nullDefaulting: Catch[Int] = failAsValue(classOf[NullPointerException])(-1)
      val otherDefaulting: Catch[Int] = nonFatalCatch withApply(_ => -100)

      val combinedDefaulting: Catch[Int] = formatDefaulting or nullDefaulting or otherDefaulting

      def p(s: String): Int = s.length * s.toInt

      // Int = 0
      combinedDefaulting(p("tenty-nine"))

      // Int = -1
      combinedDefaulting(p(null: String))

      // Int = -100
      combinedDefaulting(throw new IllegalStateException)

      // Int = 22
      combinedDefaulting(p("11"))

  Definition Classes
    control
- By
- Catch
- Described
- Finally

c

scala.util.control.Exception

# Catch 

###

#### class Catch[+T] extends Described

A container class for catch/finally logic.

Pass a different value for rethrow if you want to probably unwisely allow catching control exceptions and other throwables which the rest of the world may expect to get through.

T

  result type of bodies used in try and catch blocks

Source
  Exception.scala

Linear Supertypes
Described, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Catch
2. Described
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Catch(pf: Catcher[T], fin: Option[Finally] = None, rethrow: (Throwable) ⇒ Boolean = shouldRethrow)

   pf

     Partial function used when applying catch logic to determine result value

   fin

     Finally logic which if defined will be invoked after catch logic

   rethrow

     Predicate on throwables determining when to rethrow a caught Throwable

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Catch[T] to any2stringadd[Catch[T]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Catch[T], B)
   Implicit
     This member is added by an implicit conversion from Catch[T] to ArrowAssoc[Catch[T]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
6.  def andFinally(body: ⇒ Unit): Catch[T]

   Create a new Catch container from this object and the supplied finally body.

   Create a new Catch container from this object and the supplied finally body.

   body

     The additional logic to apply after all existing finally bodies

7.  def apply[U >: T](body: ⇒ U): U

   Apply this catch logic to the supplied body.

8.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9.  def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10.  def desc: String
    Definition Classes
      Described
11.  def either[U >: T](body: ⇒ U): Either[Throwable, U]

    Apply this catch logic to the supplied body, mapping the result into `Either[Throwable, T]` - `Left(exception)` if an exception was caught, `Right(T)` otherwise.

12.  def ensuring(cond: (Catch[T]) ⇒ Boolean, msg: ⇒ Any): Catch[T]
    Implicit
      This member is added by an implicit conversion from Catch[T] to Ensuring[Catch[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: (Catch[T]) ⇒ Boolean): Catch[T]
    Implicit
      This member is added by an implicit conversion from Catch[T] to Ensuring[Catch[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean, msg: ⇒ Any): Catch[T]
    Implicit
      This member is added by an implicit conversion from Catch[T] to Ensuring[Catch[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean): Catch[T]
    Implicit
      This member is added by an implicit conversion from Catch[T] to Ensuring[Catch[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
17.  def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
18.  val fin: Option[Finally]
19.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

20.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from Catch[T] to StringFormat[Catch[T]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
21.  final def getClass(): Class[_]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
22.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
23.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
24.  val name: String
    Attributes
      protected
    Definition Classes
      Catch → Described
25.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
26.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

27.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

28.  def opt[U >: T](body: ⇒ U): Option[U]

    Apply this catch logic to the supplied body, mapping the result into `Option[T]` - `None` if any exception was caught, `Some(T)` otherwise.

29.  def or[U >: T](other: Catch[U]): Catch[U]
30.  def or[U >: T](pf2: Catcher[U]): Catch[U]

    Create a new Catch with additional exception handling logic.

31.  val pf: Catcher[T]
32.  val rethrow: (Throwable) ⇒ Boolean
33.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
34.  def toEither: Catch[Either[Throwable, T]]
35.  def toOption: Catch[Option[T]]

    Convenience methods.

36.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      Described → AnyRef → Any
37.  def toTry: Catch[Try[T]]
38.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
39.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
40.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
41.  def withApply[U](f: (Throwable) ⇒ U): Catch[U]

    Create a `Catch` object with the same `isDefinedAt` logic as this one, but with the supplied `apply` method replacing the current one.

42.  def withDesc(s: String): Catch.this.type
    Definition Classes
      Described
43.  def withTry[U >: T](body: ⇒ U): Try[U]

    Apply this catch logic to the supplied body, mapping the result into `Try[T]` - `Failure` if an exception was caught, `Success(T)` otherwise.

44.  def →[B](y: B): (Catch[T], B)
    Implicit
      This member is added by an implicit conversion from Catch[T] to ArrowAssoc[Catch[T]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Described

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Catch[T] to any2stringadd[Catch[T]]

### Inherited by implicit conversion StringFormat from Catch[T] to StringFormat[Catch[T]]

### Inherited by implicit conversion Ensuring from Catch[T] to Ensuring[Catch[T]]

### Inherited by implicit conversion ArrowAssoc from Catch[T] to ArrowAssoc[Catch[T]]

### Ungrouped